--[[
	Capship Tab written by Seryn
	version 1.3.0
	based on mdi-targetlist tab system by draugath
--]]

declare("Capship_tab", {
	version = "1.3.0",
})


local T = {
	Tab = {
		title = "Capship",
		columns = {
			{
				title = "Index",
				width = 0,
			},
			{
				title = "Commands",
				width = 1,
			},
		},
		filters = {
			{
				title = "Commands",
				pages = {
					{
						title = "CMD",
						fgcolor = "235 52 88 225 *",
						bgcolor = "52 116 235 225 *",
					},	
					{
						title = "PVE",
						fgcolor = "52 192 235 225 *",
						bgcolor = "34 49 163 225 *",
					},
				},
			},
			{
				title = "Features",
			},
			{
				title = "Turrets",
			},
			{
				title = "Ships",
			},
		},
		--------------
		

		currentList = {},
		filter_index = -1,
	}
}

Capship_tab.T = T
T.Tab.mainCommandList = {
	{
		"1",
		"\12759a5d8** Follow ME",
	},
	{
		"2",
		"\12750b8cf** Follow Target",
	},
	{ 
		"3",
		"\12773c7bd** Park",
	},
	{	
		"4",
		"\127a2d1b0** Turbo",
	},
	{	
		"5",
		"\127ced8b0** Shield",
	},
	{	
		"6",
		"\127f3dfbf** Attack Target",
	},
	{	
		"7",
		"\127a2d1b0** Defend Target",
	},
	{	
		"8",
		"\12773c7bd** Patrol",
	},
	{	
		"9",
		"\12750b8cf** Cease Fire",
	}
}
T.Tab.pveCommandList = {
	{
		"1",
		"\12759a5d8** Follow ME",
	},
	{
		"2",
		"\12750b8cf** Follow Target",
	},
	{ 
		"3",
		"\12773c7bd** Park",
	},
	{	
		"4",
		"\127a2d1b0** Prepare for docking",
	},
	{	
		"5",
		"\127ced8b0** Mine",
	},
	{	
		"6",
		"\127f3dfbf** Gather Target Ore",
	},
}
T.Tab.featuresList = {
	{
		"1",
		"\12759a5d8** Autocontrol on docking ON/OFF",
	},
	{
		"2",
		"\12750b8cf** Switch Control Trident/Goliath",
	},
	{
		"3",
		"\12773c7bd** Give Capship Key",
	},
	{ 
		"4",
		"\127a2d1b0** Revoke Capship Key",
	},
	{	
		"5",
		"\127ced8b0** Plot Route to Capship",
	},
	{	
		"6",
		"\127f3dfbf** Kick All Gunners",
	},
	{	
		"7",
		"\127a2d1b0** Dismiss All Gunners",
	},
	
	
}
T.Tab.turretList = {
	{	
		"1",
		"\12759a5d8** Enable/Disable Turret 1",
	},
	{	
		"2",
		"\12750b8cf** Enable/Disable Turret 2",
	},
	{	
		"3",
		"\12773c7bd** Enable/Disable Turret 3",
	},
	{	
		"4",
		"\127a2d1b0** Enable/Disable Turret 4",
	},
	{	
		"5",
		"\127ced8b0** Enable/Disable ALL Turrets",
	},
	{	
		"6",
		"\127f3dfbf** Enable/Disable MISSILE Turrets",
	},
	{	
		"7",
		"\127a2d1b0** Enter Turret 1",
	},
	{	
		"8",
		"\12773c7bd** Enter Turret 2",
	},
	{	
		"9",
		"\12750b8cf** Enter Turret 3",
	},
	{	
		"10",
		"\12759a5d8** Enter Turret 4",
	},
}
T.Tab.shipsList = {
	{	
		"1",
		"\12759a5d8** Undock Ship 1",
	},
	{	
		"2",
		"\12750b8cf** Undock Ship 2",
	},
	{	
		"3",
		"\12773c7bd** Undock Ship 3",
	},
	{	
		"4",
		"\127a2d1b0** Undock Ship 4",
	},
	{	
		"5",
		"\127ced8b0** Undock Ship 5",
	},
	{	
		"6",
		"\127f3dfbf** Undock Ship 6",
	},
}

T.Tab.ship = {}
T.Tab.ship.tridentName = " "
T.Tab.ship.goliathName = " "
T.Tab.ship.tridentKey = " "
T.Tab.ship.goliathKey = " "
T.Tab.ship.controlTrident = true
T.Tab.ship.controlGoliath = false
T.Tab.ship.autocontrolCapship = false
T.Tab.ship.turretDisabled1 = false
T.Tab.ship.turretDisabled2 = false
T.Tab.ship.turretDisabled3 = false
T.Tab.ship.turretDisabled4 = false
T.Tab.ship.turretDisabledALL = false
T.Tab.ship.turretDisabledMISSILE = false
T.Tab.ship.shieldNotifyMode = "0"
T.Tab.sendTimer = Timer()
T.Tab.systemnotes = 1120003470

local pCommand = gkinterface.GKProcessCommand


-- tab change to capship tab, update list.. maybe useful later
function T.Tab:TARGETLIST_TAB_CHANGED()
	self.is_active = targetlist.API.IsActiveTab(T.Tab)
	if (self.is_active) then
		targetlist.API.UpdateDisplay(self, self.currentList)
	end
end

function T.Tab:ChangeFilter(index, page)
	T.Tab.filter_index = index
	T.Tab.filter_page = page
	if self.filter_index == 1 and self.filter_page == 1 then
		T.Tab.currentList = T.Tab.mainCommandList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 1 and self.filter_page == 2 then
		T.Tab.currentList = T.Tab.pveCommandList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 2 then
		T.Tab.currentList = T.Tab.featuresList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 3 then
		T.Tab.currentList = T.Tab.turretList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 4 then
		T.Tab.currentList = T.Tab.shipsList
		targetlist.API.UpdateDisplay(self, self.currentList)
	end
end

-- 
function T.Tab:ChangeTarget(_, listEntryID)
	
	
	local listEntryID = listEntryID
	
	if self.filter_index == 1 and self.filter_page == 1 then
		T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
		local shipName = ""
			if T.Tab.ship.controlTrident == true then
				shipName = T.Tab.ship.tridentName
			elseif T.Tab.ship.controlGoliath == true then 
				shipName = T.Tab.ship.goliathName
			else
				print("\12750b8cfNo Capship specified. Please setup the Capship Tab with /capshipsetup \127o")
			end
		-- /msg shipname follow
		if listEntryID == 1 then
			local msg = "follow"
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname follow targetname
		elseif listEntryID == 2 then
			local targetName, _, _, _, _, _ = GetTargetInfo()
			
			if targetName ~= nil then 
				local msg = "follow " .. targetName
				if targetName:match("Asteroid") or targetName:match("Ice Crystal") then
					print("\12750b8cfAsteroid too slow. The pilot is at risk of falling asleep while following, please target a player.\127o")
				elseif targetName:match("cu%)") then
					print("\12750b8cfCargo crates can\'t fly. Please target a player to follow.\127o")
				else
					SendChat(msg, "PRIVATE", shipName)
				end
			end

		-- /msg shipname park
		elseif listEntryID == 3 then
			local msg = "park";
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname turbo
		elseif listEntryID == 4 then
			local msg = "turbo"
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname shield
		elseif listEntryID == 5 then
			local msg = "shield"
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname attack targetname
		elseif listEntryID == 6 then
			local targetName, _, _, _, _, _ = GetTargetInfo()
			if targetName ~= nil then
				local msg = "attack " .. targetName
				if targetName:match("Asteroid") or targetName:match("Ice Crystal") then
					print("\12750b8cfAsteroids don't make good targets. Find something more challenging to shoot and please target a player.\127o")
				elseif targetName:match("cu%)") then
					print("\12750b8cfCargo crates make lame opponents. Please target a capship to attack.\127o")
				else
					SendChat(msg, "PRIVATE", shipName)
				end
			end

		-- /msg shipname defend targetname
		elseif listEntryID == 7 then
			local targetName, _, _, _, _, _ = GetTargetInfo()
			if targetName ~= nil then 
				local msg = "defend " .. targetName
				if targetName:match("Asteroid") or targetName:match("Ice Crystal") then
					print("\12750b8cfCapship unwilling to sacrifice itself to save an asteroid, please target a player.\127o")
				elseif targetName:match("cu%)") then
					print("\12750b8cfJust scoop the cargo, there is no need to defend it. Please target a player to defend.\127o")
				else
					SendChat(msg, "PRIVATE", shipName)
				end
			end

		-- /msg shipname patrol
		elseif listEntryID == 8 then
			local msg = "patrol"
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname cease fire
		elseif listEntryID == 9 then
			local msg = "cease fire"
			SendChat(msg, "PRIVATE", shipName)

		--
		elseif listEntryID == 10 then
			return
		end

	-- pve tab
	elseif self.filter_index == 1 and self.filter_page == 2 then
		T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
		local shipName = ""
			if T.Tab.ship.controlTrident == true then
				shipName = T.Tab.ship.tridentName
			elseif T.Tab.ship.controlGoliath == true then 
				shipName = T.Tab.ship.goliathName
			else
				print("\12750b8cfNo Capship specified. Please setup the Capship Tab with /capshipsetup \127o")
			end
		-- /msg shipname follow
		if listEntryID == 1 then
			local msg = "follow"
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname follow targetname
		elseif listEntryID == 2 then
			local targetName, _, _, _, _, _ = GetTargetInfo()
			if targetName ~= nil then
				local msg = "follow " .. targetName
				if targetName:match("Asteroid") or targetName:match("Ice Crystal") then
					print("\12750b8cfAsteroid too slow. The pilot is at risk of falling asleep while following, please target a player.\127o")
				elseif targetName:match("cu%)") then
					print("\12750b8cfCargo crates can\'t fly. Please target a player to follow.\127o")
				else
					SendChat(msg, "PRIVATE", shipName)
				end
			end

		-- /msg shipname park
		elseif listEntryID == 3 then
			local msg = "park";
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname prepare for docking
		elseif listEntryID == 4 then
			local msg = "prepare for docking"
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname mine
		elseif listEntryID == 5 then
			local msg = "mine"
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname gather targetore
		elseif listEntryID == 6 then
			local targetOre = GetTargetInfo()
			if targetOre ~= nil then
				if targetOre:match("Premium") then
					local split, rest = string.match(targetOre, "(.*)Ore(.*)")
					local searchOre = string.sub(split, 9)
					local msg = "gather " .. searchOre;
					SendChat(msg, "PRIVATE", shipName)
				else
					local split, rest = string.match(targetOre, "(.*)Ore(.*)")
					local searchOre = split
					local msg = "gather " .. searchOre;
					SendChat(msg, "PRIVATE", shipName)
				end
			end
		elseif listEntryID == 7 then
			return
		elseif listEntryID == 8 then
			return
		elseif listEntryID == 9 then
			return
		elseif listEntryID == 10 then
			return
		end

	-- management tab
	elseif self.filter_index == 2 then
		-- autocontrol when docking
		if listEntryID == 1 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
			if T.Tab.ship.autocontrolCapship == false then
				T.Tab.ship.autocontrolCapship = true
				print("\12750b8cfAutocontrol for capship is ON.\127o")
			else
				T.Tab.ship.autocontrolCapship = false
				print("\12750b8cfAutocontrol for Capship is OFF.\127o")
			end
			SaveSystemNotes(spickle(T.Tab.ship), T.Tab.systemnotes)

		-- switch between capships to control via the capship tab
		elseif listEntryID == 2 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));

			local goliathName = T.Tab.ship.goliathName or "None"
			local tridentName = T.Tab.ship.tridentName or "None"

			if (T.Tab.ship.controlTrident == true) and (goliathName ~= " " or "None") then
				T.Tab.ship.controlTrident = false
				T.Tab.ship.controlGoliath = true
				print("\12750b8cfCapship Control now set to: " .. goliathName .. "\127o")
				
			elseif (T.Tab.ship.controlTrident == true) and (goliathName == " " or "None") then
				T.Tab.ship.controlTrident = true
				T.Tab.ship.controlGoliath = false
				print("\12750b8cfNo Goliath assigned. Capship Control now set to: " .. tridentName .. "\127o")
				
			elseif (T.Tab.ship.controlTrident == false) and (tridentName ~= " " or "None") then
				T.Tab.ship.controlTrident = true
				T.Tab.ship.controlGoliath = false
				print("\12750b8cfCapship Control now set to: " .. tridentName .. "\127o")
				
			elseif (T.Tab.ship.controlTrident == false) and (tridentName == " " or "None") then
				T.Tab.ship.controlTrident = false
				T.Tab.ship.controlGoliath = true
				print("\12750b8cfNo Trident assigned. Capship Control now set to: " .. goliathName .. "\127o")
				
			else
				print("\12750b8cfError! Capship not assigned.\127o")
			end
			SaveSystemNotes(spickle(T.Tab.ship), T.Tab.systemnotes)

		-- give user key to target
		elseif listEntryID == 3 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
			local targetName = GetTargetInfo()
			if targetName ~= nil then 
				local keyID = "None"
				if T.Tab.ship.controlTrident == true then
					keyID = T.Tab.ship.tridentKey
				elseif T.Tab.ship.controlGoliath == true then 
					keyID = T.Tab.ship.goliathKey
				end
				if keyID == "None" or nil then
					print("\12750b8cfNo capship key assigned. Please use /capshipsetup\127o")
				else
					Keychain.giveuserkey(targetName, keyID)
					print("\12750b8cfCapship key given to: " .. targetName .. "\127o")
				end
			else 
				print("\12750b8cfNo target specified.\127o")
			end

		-- revoke user key of target
		elseif listEntryID == 4 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
			local targetName = GetTargetInfo()
			local keyID = "None"
			if targetName ~= nil then
				if T.Tab.ship.controlTrident == true then
					keyID = T.Tab.ship.tridentKey
				elseif T.Tab.ship.controlGoliath == true then 
					keyID = T.Tab.ship.goliathKey
				end
				if keyID == "None" or nil then
					print("\12750b8cfNo capship key assigned. Please use /capshipsetup\127o")
				else
					Keychain.revokekey(targetName, keyID)
					print("\12750b8cfCapship key revoked for: " .. targetName .. "\127o")
				end
			else
				print("\12750b8cfNo target specified.\127o")
			end

		-- plot to your capship
		elseif listEntryID == 5 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
			local stationID = " "
			local sectorID = " "
			local capLocation = " "
			local currentCapship = " "
			if T.Tab.ship.controlTrident == true then
				currentCapship = "Trident Type M"
			elseif T.Tab.ship.controlGoliath == true then
				currentCapship = "Goliath"
			else
				print("\12750b8cfError! No capship to control assigned.\127o")
			end
			
			for itemID, _ in PlayerInventoryPairs() do
				local _, shipName, _, _, shipType, _, _, containerID, _, _ = GetInventoryItemInfo(itemID)
				if shipType:match(currentCapship) and containerID > 0 then -- found a capship!
					stationID = GetInventoryItemLocation(itemID)
					sectorID = GetSectorIDOfStation(stationID)
					capLocation = AbbrLocationStr(sectorID)
				end
			end
			NavRoute.SetFinalDestination(sectorID)
			print("\12750b8cfNavroute set to: " .. capLocation .. "\127o")

		-- kick all gunners
		elseif listEntryID == 6 then
			local numberOfTurrets = GetNumStationTurrets()
			local turretID = 1
			local turretInfo = {}
			local ownCharID = GetCharacterID()
			if numberOfTurrets == 0 or nil then
				print("\12750b8cfYour ship has no Turrets!\127o")
			else
				while turretID <= numberOfTurrets do
					local turretInfo = GetStationTurretInfo(turretID)
					local gunnerCharID = turretInfo.controller
					if (gunnerCharID ~= ownCharID) and (gunnerCharID ~= nil) then
						Gunner.Kick(GetPlayerName(gunnerCharID))
					end
					turretID = turretID + 1
				end
				print("\12750b8cfAll gunners ejected from the ship.\127o")
			end

		-- dismiss all gunners
		elseif listEntryID == 7 then
			local numberOfTurrets = GetNumStationTurrets()
			local turretID = 1
			local turretInfo = {}
			local gunnerCharID = 0
			local ownCharID = GetCharacterID()
			if numberOfTurrets == 0 then
				print("\12750b8cfYour ship has no Turrets!\127o")
			else
				while turretID <= numberOfTurrets do
					turretInfo = GetStationTurretInfo(turretID)
					gunnerCharID = turretInfo.controller
					if (gunnerCharID ~= ownCharID) and (gunnerCharID ~= nil) then
						Gunner.Dismiss(GetPlayerName(gunnerCharID))
					end
					turretID = turretID + 1
				end
				print("\12750b8cfAll gunners dismissed from their turrets.\127o")
			end
		-- shield notifcation mode
		elseif listEntryID == 8 then
			return
		-- 
		elseif listEntryID == 9 then
			return
		--
		elseif listEntryID == 10 then
			return
		end


	-- turret options tab
	elseif self.filter_index == 3 then
		-- enable/disable turret 1
		if listEntryID == 1 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
			local turretStatus = T.Tab.ship.turretDisabled1
			if turretStatus == false then
				T.Tab.ship.turretDisabled1 = true
				pCommand("disableturret 1")
			else
				T.Tab.ship.turretDisabled1 = false
				pCommand("enableturret 1")
			end
			SaveSystemNotes(spickle(T.Tab.ship), T.Tab.systemnotes)
			
		-- enable/disable turret 2
		elseif listEntryID == 2 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
			local turretStatus = T.Tab.ship.turretDisabled2
			if turretStatus == false then
				T.Tab.ship.turretDisabled2 = true
				pCommand("disableturret 2")
			else
				T.Tab.ship.turretDisabled2 = false
				pCommand("enableturret 2")
			end
			SaveSystemNotes(spickle(T.Tab.ship), T.Tab.systemnotes)
			
		-- enable/disable turret 3
		elseif listEntryID == 3 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
			local turretStatus = T.Tab.ship.turretDisabled3
			if turretStatus == false then
				T.Tab.ship.turretDisabled3 = true
				pCommand("disableturret 3")
			else
				T.Tab.ship.turretDisabled3 = false
				pCommand("enableturret 3")
			end
			SaveSystemNotes(spickle(T.Tab.ship), T.Tab.systemnotes)

		-- enable/disable turret 4
		elseif listEntryID == 4 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
			local turretStatus = T.Tab.ship.turretDisabled4
			if turretStatus == false then
				T.Tab.ship.turretDisabled4 = true
				pCommand("disableturret 4")
			else
				T.Tab.ship.turretDisabled4 = false
				pCommand("enableturret 4")
			end
			SaveSystemNotes(spickle(T.Tab.ship), T.Tab.systemnotes)

		-- enable/disable ALL turrets
		elseif listEntryID == 5 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
			local turretStatus = T.Tab.ship.turretDisabledALL
			if turretStatus == false then
				T.Tab.ship.turretDisabledALL = true
				pCommand("disableturret all")
			else
				T.Tab.ship.turretDisabledALL = false
				pCommand("enableturret all")
			end
			SaveSystemNotes(spickle(T.Tab.ship), T.Tab.systemnotes)

		-- enable/disable MISSILE turrets
		elseif listEntryID == 6 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
			local turretStatus = T.Tab.ship.turretDisabledMISSILE
			if turretStatus == false then
				T.Tab.ship.turretDisabledMISSILE = true
				pCommand("disableturret missiles")
			else
				T.Tab.ship.turretDisabledMISSILE = false
				pCommand("enableturret missiles")
			end
			SaveSystemNotes(spickle(T.Tab.ship), T.Tab.systemnotes)

		-- enter turret 1
		elseif listEntryID == 7 then
			pCommand("enterturret 1")
		-- enter turret 2
		elseif listEntryID == 8 then
			pCommand("enterturret 2")

		-- enter turret 3
		elseif listEntryID == 9 then
			pCommand("enterturret 3")

		-- enter turret 4
		elseif listEntryID == 10 then
			pCommand("enterturret 4")
		end

	-- ship options tab
	elseif self.filter_index == 4 then
		-- undock first stored ship
		if listEntryID == 1 then
			local shipList = GetShipList()
			if shipList[1] ~= nil then
			print("\12750b8cfShip #1 found. Undocking...\127o") 
			RequestLaunch(GetShipList()[1])
			else
				print("\12750b8cfThe requested Ship is not here. Did you misplace it?\127o")
			end
			
		-- undock second stored ship
		elseif listEntryID == 2 then
			local shipList = GetShipList()
			if shipList[2] ~= nil then
				print("\12750b8cfShip #2 found. Undocking...\127o") 
				RequestLaunch(GetShipList()[2])
			else
				print("\12750b8cfThe requested Ship is not here. Did you misplace it?\127o")
			end
			
		-- undock third stored ship
		elseif listEntryID == 3 then
			local shipList = GetShipList()
			if shipList[3] ~= nil then
				print("\12750b8cfShip #3 found. Undocking...\127o") 
				RequestLaunch(GetShipList()[3])
			else
				print("\12750b8cfThe requested Ship is not here. Did you misplace it?\127o")
			end
		-- undock fourth stored ship
		elseif listEntryID == 4 then
			local shipList = GetShipList()
			if shipList[4] ~= nil then
				print("\12750b8cfShip #4 found. Undocking...\127o") 
				RequestLaunch(GetShipList()[4])
			else
				print("\12750b8cfThe requested Ship is not here. Did you misplace it?\127o")
			end
		-- undock fifth stored ship
		elseif listEntryID == 5 then
			local shipList = GetShipList()
			if shipList[5] ~= nil then
				print("\12750b8cfShip #5 found. Undocking...\127o") 
				RequestLaunch(GetShipList()[5])
			else
				print("\12750b8cfThe requested Ship is not here. Did you misplace it?\127o")
			end

		-- undock sixth stored ship
		elseif listEntryID == 6 then
			local shipList = GetShipList()
			if shipList[6] ~= nil then
				print("\12750b8cfShip #6 found. Undocking...\127o") 
				RequestLaunch(GetShipList()[6])
			else
				print("\12750b8cfThe requested Ship is not here. Did you misplace it?\127o")
			end

		-- 
		elseif listEntryID == 7 then
			return

		-- 
		elseif listEntryID == 8 then
			return

		-- 
		elseif listEntryID == 9 then
			return

		-- 
		elseif listEntryID == 10 then
			return

		end
	end
	
end


-- take control of capship if enter_station event is triggered and autocontrol is true
function T.Tab.autoControl(event, data)
	T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
	local stationType = GetStationType()
	if T.Tab.ship.autocontrolCapship == true and stationType ~= nil then
		ControlOwnCapship()
	end
end



local chatreceiver_old = chatreceiver.OnEvent
function chatreceiver:OnEvent(event, data)
	if event == "CHAT_MSG_PRINT" then
		local msg = data.msg
		if msg == "<CLICK!> Out of missiles!" then
			HUD:PrintSecondaryMsg("\127ffff8c<CLICK!> Out of missiles!\127o")
		else
			chatreceiver_old(chatreceiver, event, data) 
		end
	else
		chatreceiver_old(chatreceiver, event, data)
    end
end


-- check if plugin was loaded correctly
function T.Tab:PLUGINS_LOADED()
	if (isdeclared("targetlist") and targetlist.API) then
		if (targetlist.API.Version >= 1) then
			targetlist.API.RegisterTab(T.Tab)
		else
			print("\12750b8cfMDI-TargetList API version is not compatible. Capship Tab was not loaded.\127o")
		end
	end
end

-- check if targetlist is even installed
function T.Tab:PLAYER_ENTERED_GAME()
	if (not (isdeclared("targetlist") and targetlist.API)) then
		print("\12750b8cfCapship Tab for MDI-TargetList requires version 4 or higher.\127o")
	end
end



dofile("config.lua")

RegisterEvent(T.Tab, "TARGETLIST_TAB_CHANGED")
RegisterEvent(T.Tab, "PLUGINS_LOADED")
RegisterEvent(T.Tab, "PLAYER_ENTERED_GAME")
RegisterEvent(T.Tab.autoControl, "ENTERED_STATION")
